#ifndef _ItemBufferQueryManager_H__
#define _ItemBufferQueryManager_H__

#include "OgrePlatformQueryManager.h"

namespace Ogre {
  
/**
	Class which implements the QueryManager for Ogre scene queries.
*/
class __declspec(dllexport) ItemBufferQueryManager: public PlatformQueryManager
{
public:
    /** Constructor taking a hierarchy interface as an argument. This allows to operate
	onm different hierarchy types, while reusing the implementation of the query methods.
    */
	ItemBufferQueryManager(PlatformHierarchyInterface *hierarchyInterface, Viewport *vp);
    
    void ComputeCameraVisibility(const Camera &camera,
			    InfoContainer<GtpVisibility::NodeInfo> *visibleNodes,
			    InfoContainer<GtpVisibility::MeshInfo> *visibleGeometry,
			    bool relativeVisibility = false);
    
	bool ShootRay(const Ray &ray, std::vector<Mesh *> *visibleMeshes, bool isGlobalLine = false);  
	
protected:
	void InitItemBuffer( InfoContainer<GtpVisibility::NodeInfo> *visibleNodes,
			    InfoContainer<GtpVisibility::MeshInfo> *visibleGeometry);
	
};

} // namespace Ogre

#endif // ItemBufferQueryManager
